<?php

/*********************************************************************

 一行BBSのdisplayプラグイン (2018/06/17)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

/* メイン処理 */
function freo_display_linebbs()
{
	global $freo;

	//検索条件設定
	$condition = null;
	if (isset($_GET['word'])) {
		$condition .= ' AND text LIKE ' . $freo->pdo->quote('%' . $_GET['word'] . '%');
	}
	if (isset($_GET['name'])) {
		$condition .= ' AND name LIKE ' . $freo->pdo->quote('%' . $_GET['name'] . '%');
	}
	if (isset($_GET['date'])) {
		if (preg_match('/^\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		} elseif (preg_match('/^\d\d\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y%m\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y%m\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		} elseif (preg_match('/^\d\d\d\d\d\d\d\d$/', $_GET['date'])) {
			if (FREO_DATABASE_TYPE == 'mysql') {
				$condition .= ' AND DATE_FORMAT(created, \'%Y%m%d\') = ' . $freo->pdo->quote($_GET['date']);
			} else {
				$condition .= ' AND STRFTIME(\'%Y%m%d\', created) = ' . $freo->pdo->quote($_GET['date']);
			}
		}
	}
	if ($condition) {
		$condition = ' WHERE id IS NOT NULL ' . $condition;
	}

	//一行BBS取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_linebbss ' . $condition . ' ORDER BY id DESC LIMIT :limit');
	$stmt->bindValue(':limit', intval($freo->config['plugin']['linebbs']['display_limit']), PDO::PARAM_INT);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_linebbss = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_linebbss[$data['id']] = $data;
	}

	//一行BBS数・ページ数取得
	$stmt = $freo->pdo->query('SELECT COUNT(*) FROM ' . FREO_DATABASE_PREFIX . 'plugin_linebbss ' . $condition);
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	$data                 = $stmt->fetch(PDO::FETCH_NUM);
	$plugin_linebbs_count = $data[0];
	$plugin_linebbs_page  = ceil($plugin_linebbs_count / $freo->config['plugin']['linebbs']['display_limit']);

	//データ割当
	$freo->smarty->assign(array(
		'token'                => freo_token('create'),
		'plugin_linebbss'      => $plugin_linebbss,
		'plugin_linebbs_count' => $plugin_linebbs_count,
		'plugin_linebbs_page'  => $plugin_linebbs_page
	));

	return;
}

?>
